clear
close all

% load data
load mnistSubset.mat

% only consider digits 1 and 2 (labels 2 and 3)
K = 2;
Xtrain = [];
ytrain = [];
Xtest = [];
ytest = [];
for kk = 1:K
    Xk = X(:,trueLabels==kk+1);
    Xtrain = [Xtrain Xk(:,1:100)];
    Xtest = [Xtest Xk(:,101:end)];
    ytrain = [ytrain; kk*ones(100,1)];
    ytest = [ytest; kk*ones(100,1)];
end

% make labels +1/-1
ytrain = (2*(ytrain - 1) - 1);
ytest = (2*(ytest - 1) - 1);

%% YOUR CODE
% reduce dimension of data using PCA and plot

%% Part b
% train using standard gradient descent
numIter = 20;
lambda = 0.001;
[wgd,gdCost] = osmgd(Xtrain,ytrain,lambda,numIter);

% plot separator
xx = linspace(0,8,100);
yy = -wgd(1)*xx/wgd(2);
plot(xx,yy)

% compute train and test error

%% Part c
% train using stochastic gradient descent
[wsgd,sgdCost] = osmsgd(Xtrain,ytrain,lambda,numIter);

% plot separator
xx = linspace(0,8,100);
yy = -wsgd(1)*xx/wsgd(2);
plot(xx,yy)
legend('full data','GD separator','SGD separator','location','northwest')

% compute train and test error

% plot cost vs iteration
figure
hold all
plot(1:numIter,gdCost)
plot(1:numIter,sgdCost)
title('Hinge Loss')
legend('GD','SGD')

%% Part d
% plot all separators together with data
